#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <crypt.h>


int verifica(char* u, char* p) {

	// File mypasswd
	FILE* fd;

	// Riga del file mypasswd
	char line[512];

	// Campo username di una riga del file
	char usr[512];

	// Password cifrata di una riga del file
	char epwd[512];

	// Salt estratto da una riga del file
	char salt[2];

	// Password inserita dall'utente e cifrata
	char res[512];

	// Apro il file mypasswd
	fd = fopen("mypasswd", "r");
	if(!fd) 
		return 0;		

	// Leggo tutte le righe del file
	while(fgets(line, sizeof(line), fd)){
		
		// Estraggo username e password dalla riga appena letta
		sscanf(line, "%s %s", usr, epwd);

		// Estraggo il salt
		salt[0] = epwd[0];	
		salt[1] = epwd[1];	

		// Cifro la password inserita dall'utente, uso il salt appena estratto
		strncpy(res, crypt(p, salt), sizeof(res));	

		// username e password cifrata coincidono con quelli del file, l'utente
		// ha eseguito login con successo
		if(strcmp(u,usr) == 0 && strcmp(res,epwd) == 0) 
			return 1;
	}
	
	// login fallito
	return 0;
}

int main(int argc,char* argv[]) {

	// Username inserito dall'utente
	char username[512];

	// Password inserita dall'utente
	char password[512];
	
	// Controllo il numero di parametri
	if(argc != 1) {
		printf("Wrong number of parameters\n");
		printf("USAGE: %s\n", argv[0]);
		exit(1);
	}

	// Leggo da tastiera nome utente e password fino a quando 
	// non vengono inseriti i dati corretti
	while(1) {

		// Legge il nome utente
		printf("login:");
		scanf("%s", username);

		// Legge la password
		printf("password:");	
		scanf("%s", password);

		// Verifica se il file mypasswd contiene la coppia nome utente + password 
		if(verifica(username, password)) 
			break;
		else {
			printf("Nome utente e/o password scorretti\n");
		}
	}
	
	// L'utente ha inserito credenziali valide
	printf("Welcome %s\n", username);	
	exit(0);
}
